SpawningOptions = {}

-- Money SPAWNER


function SpawningOptions.SpawnPickupMoney(model)
	local hash = natives.GAMEPLAY.GET_HASH_KEY(model)
	local coords = natives.ENTITY.GET_OFFSET_FROM_ENTITY_IN_WORLD_COORDS(plyPed, 0, 0, 0)
	natives.OBJECT.CREATE_AMBIENT_PICKUP(hash, coords.x, coords.y, coords.z+5, 0, 40000, 1, false, true);
end


	

-- VEHICLE SPAWNER

function SpawningOptions.SpawnVehicle(model)
	local hash = natives.GAMEPLAY.GET_HASH_KEY(model)
	local coords = natives.ENTITY.GET_OFFSET_FROM_ENTITY_IN_WORLD_COORDS(plyPed, 0, 5, 2)
	local heading = natives.ENTITY.GET_ENTITY_HEADING(plyPed) + 90

	streaming.RequestModel(hash)
	
	local veh = natives.VEHICLE.CREATE_VEHICLE(hash, coords.x, coords.y, coords.z, heading, true, true)
	
	if SpawnedVehicles == nil then SpawnedVehicles = {} end
	table.insert(SpawnedVehicles, veh)
end


function SpawningOptions.RemoveSpawnedVehicles()
	if SpawnedVehicles ~= nil then
		for k,v in pairs(SpawnedVehicles) do
			if natives.PED.IS_PED_IN_VEHICLE(plyPed, v, false) == false then
				c_veh = CMemoryBlock(4)
				c_veh:WriteDWORD32(0, v)
				natives.ENTITY.DELETE_ENTITY(c_veh) 
				c_veh:Release()
			end
		end
		SpawnedVehicles = nil
	end
end



-- PED SPAWNER


function SpawningOptions.SpawnPed(model)
	local hash = natives.GAMEPLAY.GET_HASH_KEY(model)
	local coords = natives.ENTITY.GET_OFFSET_FROM_ENTITY_IN_WORLD_COORDS(plyPed, 0, 5, 2)
	local heading = natives.ENTITY.GET_ENTITY_HEADING(plyPed) + 90

	streaming.RequestModel(hash)
	
	local ped = natives.PED.CREATE_PED(26, hash, coords.x, coords.y, coords.z, heading, true, true)
	
	if SpawnedPeds == nil then SpawnedPeds = {} end
	table.insert(SpawnedPeds, ped)
end


function SpawningOptions.RemoveSpawnedPeds()
	if SpawnedPeds ~= nil then
		for k,v in pairs(SpawnedPeds) do
			c_ped = CMemoryBlock(4)
			c_ped:WriteDWORD32(0, v)
			natives.ENTITY.DELETE_ENTITY(c_ped) 
			c_ped:Release()
		end
		SpawnedPeds = nil
	end
end

function SpawningOptions.SpawnObject(model)
	local hash = natives.GAMEPLAY.GET_HASH_KEY(model)
	local coords = natives.ENTITY.GET_OFFSET_FROM_ENTITY_IN_WORLD_COORDS(plyPed, 0, 5, 2)
	natives.OBJECT.CREATE_OBJECT(hash, coords.x, coords.y, coords.z, true, true, true)
	natives.OBJECT.SET_OBJECT_COLLISION(hash, true)
	natives.OBJECT.FREEZE_OBJECT_POSITION(hash, true)
	natives.OBJECT.FREEZE_OBJECT_POSITION(hash, false)

end

-- spawningoptions tick
function SpawningOptions.tick()

end

-- spawningoptions init
function SpawningOptions.init()
	VehicleMenuGUI.createMenu("VehicleSpawner", "VehicleOptions", "~b~V~y~e~b~h~y~i~b~c~y~l~b~e ~y~S~b~p~y~a~b~w~y~n~b~e~y~r~n~~h~~y~ ∑~b~-------------~y~∑", 0.93, 0.04, 0.125, 0.0625, 0.000, 0.5, 7)
	VehicleMenuGUI.addButton("VehicleSpawner", "Unsorted Spawner", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenu1", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawner", "Sorted Spawner", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuCategories1", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawner", "Remove Vehicles", SpawningOptions.RemoveSpawnedVehicles, nil, false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawner", "~h~~y~ Close~n~~h~~y~∑~b~----------------------------~y~∑", MainMenu.CloseMenu, "", false, 0.35, 0)

	VehicleMenuGUI.createMenu("PedSpawner", "SpawningOptions", "~b~P~y~e~b~d ~y~S~b~p~y~a~b~w~y~n~b~e~y~r~n~~h~~y~ ∑~b~-------------~y~∑", 0.93, 0.04, 0.125, 0.0625, 0.000, 0.5, 7)
	VehicleMenuGUI.addButton("PedSpawner", "Ped Spawner", VehicleMenuGUI.setActiveMenu, "PedSpawnerMenu1", false, 0.35, 0)
	VehicleMenuGUI.addButton("PedSpawner", "Remove Peds", SpawningOptions.RemoveSpawnedPeds, nil, false, 0.35, 0)
	VehicleMenuGUI.addButton("PedSpawner", "~h~~y~ Close~n~~h~~y~∑~b~----------------------------~y~∑", MainMenu.CloseMenu, "", false, 0.35, 0)
	
	VehicleMenuGUI.createMenu("MoneySpawner", "SpawningOptions", "~b~M~y~o~b~n~y~e~b~y ~y~S~b~p~y~a~b~w~y~n~b~e~y~r~n~~h~~y~ ∑~b~-------------~y~∑", 0.93, 0.04, 0.125, 0.0625, 0.000, 0.5, 7)
	VehicleMenuGUI.addButton("MoneySpawner", "Money Spawner", VehicleMenuGUI.setActiveMenu, "MoneySpawnerMenu", false, 0.35, 0)
	VehicleMenuGUI.addButton("MoneySpawner", "~h~~y~ Close~n~~h~~y~∑~b~----------------------------~y~∑", MainMenu.CloseMenu, "", false, 0.35, 0)
	
	for k, SortedName in pairs(SortedVehicleNames) do
		VehicleMenuGUI.createMenu("VehicleSpawnerMenu" .. SortedName, "VehicleSpawnerMenuCategories1", "~b~C~y~a~b~r ~y~S~b~p~y~a~b~w~y~n~b~e~y~r", 0.93, 0.04, 0.125, 0.0150, 0.000, 0.35, 7, false)
	end
		
	for i, v in pairs(SortedVehicles1) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuCompacts", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuCompacts", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles2) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSedans", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSedans", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles3) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSUVs", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSUVs", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles4) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuCoupes", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuCoupes", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles5) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuMuscle", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuMuscle", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles6) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSports_Classics", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSports_Classics", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles7) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSports", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSports", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles8) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSuperCars", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuSuperCars", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	for i, v in pairs(SortedVehicles9) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuMotorcycles", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuMotorcycles", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles10) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuOff_road", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuOff_road", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles11) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuIndustrial", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuIndustrial", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles12) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuUtility", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuUtility", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles13) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuVans", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuVans", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles14) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuBicycles", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuBicycles", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles15) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuBoats", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuBoats", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles16) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuHelicopters", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuHelicopters", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles17) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuAirplanes", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuAirplanes", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles18) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuServices", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuServices", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles19) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuEmergency", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuEmergency", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)


	for i, v in pairs(SortedVehicles20) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuMilitary", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuMilitary", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

		
	for i, v in pairs(SortedVehicles21) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuTrucks", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuTrucks", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

		
	for i, v in pairs(SortedVehicles22) do
		VehicleMenuGUI.addButton("VehicleSpawnerMenuOthers", v, SpawningOptions.SpawnVehicle, v, false, 0.25, 0)
	end
		VehicleMenuGUI.addButton("VehicleSpawnerMenuOthers", "~h~~y~ Close", MainMenu.CloseMenu, "", false, 0.25, 0)

	
	
	VehicleMenuGUI.createMenu("VehicleSpawnerMenuCategories1", "VehicleSpawner", "~b~V~y~e~b~h~y~i~b~c~y~l~b~e ~y~S~b~p~y~a~b~w~y~n~b~e~y~r~n~ By Kmc", 0.93, 0.04, 0.125, 0.0625, 0.000, 0.5, 7)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "~b~N~y~e~b~x~y~t", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuCategories2", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Airplanes", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuCompacts", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Bicycles", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuSedans", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Boats", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuSUVs", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Compacts", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuCoupes", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Coupes", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuMuscle", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Emergency", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuSports_Classics", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Helicopters", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuSports", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Industrial", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuSuperCars", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Military", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuMotorcycles", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Motorcycles", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuOff_road", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "Muscle", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuIndustrial", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories1", "~h~~y~ Close~n~~h~~y~∑~b~----------------------------~y~∑", MainMenu.CloseMenu, "", false, 0.35, 0)
	
	VehicleMenuGUI.createMenu("VehicleSpawnerMenuCategories2", "VehicleSpawnerMenuCategories1", "~b~V~y~e~b~h~y~i~b~c~y~l~b~e ~y~S~b~p~y~a~b~w~y~n~b~e~y~r~n~ By Kmc", 0.93, 0.04, 0.125, 0.0625, 0.000, 0.5, 7)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "OffRoad", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuUtility", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Others", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuVans", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Sedans", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuBicycles", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Services", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuBoats", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "SportClassics", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuHelicopters", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Sports", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuAirplanes", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "SuperCars", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuServices", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Suv", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuEmergency", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Trucks", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuMilitary", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Utility", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuTrucks", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "Vans", VehicleMenuGUI.setActiveMenu, "VehicleSpawnerMenuOthers", false, 0.35, 0)
	VehicleMenuGUI.addButton("VehicleSpawnerMenuCategories2", "~h~~y~ Close~n~~h~~y~∑~b~----------------------------~y~∑", MainMenu.CloseMenu, "", false, 0.35, 0)
	
	for i, v in pairs(vehList) do
		local prevMenu = "VehicleSpawnerMenu" .. i - 1
		local nextMenu = "VehicleSpawnerMenu" .. i + 1

		if prevMenu == "VehicleSpawnerMenu0" then prevMenu = "VehicleSpawner" end
		if nextMenu == "VehicleSpawnerMenu19" then nextMenu = "VehicleSpawnerMenu18" end
		VehicleMenuGUI.createMenu("VehicleSpawnerMenu" .. i, prevMenu, "~b~C~y~a~b~r ~y~S~b~p~y~a~b~w~y~n~b~e~y~r~b~ (" .. i .. "/18)", 0.93, 0.04, 0.125, 0.0400, 0.000, 0.43, 7, false)
		VehicleMenuGUI.addButton("VehicleSpawnerMenu" .. i, "~b~N~y~e~b~x~y~t", VehicleMenuGUI.setActiveMenu, nextMenu, false, 0.35, 0)

		for _, model in pairs(v) do
			VehicleMenuGUI.addButton("VehicleSpawnerMenu" .. i, model, SpawningOptions.SpawnVehicle, model, false, 0.35, 0)
		end

		VehicleMenuGUI.addButton("VehicleSpawnerMenu" .. i, "~b~C~y~l~b~o~y~s~b~e", VehicleMenuGUI.setActiveMenu, "SpawningOptions", false, 0.35, 0)
	end
	

	for i, v in pairs(pedModels) do
		local prevMenu = "PedSpawnerMenu" .. i - 1
		local nextMenu = "PedSpawnerMenu" .. i + 1

		if prevMenu == "PedSpawnerMenu0" then prevMenu = "PedSpawner" end
		if nextMenu == "PedSpawnerMenu70" then nextMenu = "PedSpawnerMenu69" end
		VehicleMenuGUI.createMenu("PedSpawnerMenu" .. i, prevMenu, "~b~P~y~e~b~d ~y~S~b~p~y~a~b~w~y~n~b~e~y~r~b~ (" .. i .. "/69)", 0.93, 0.04, 0.125, 0.0400, 0.000, 0.43, 7, false)
		VehicleMenuGUI.addButton("PedSpawnerMenu" .. i, "~b~N~y~e~b~x~y~t", VehicleMenuGUI.setActiveMenu, nextMenu, false, 0.35, 0)

		for _, model in pairs(v) do
			VehicleMenuGUI.addButton("PedSpawnerMenu" .. i, model, SpawningOptions.SpawnPed, model, false, 0.35, 0)
		end

		VehicleMenuGUI.addButton("PedSpawnerMenu" .. i, "~b~C~y~l~b~o~y~s~b~e", VehicleMenuGUI.setActiveMenu, "SpawningOptions", false, 0.35, 0)
	end
	
	VehicleMenuGUI.createMenu("MoneySpawnerMenu", "MoneySpawner", "~b~M~y~o~b~n~y~e~b~y~", 0.93, 0.04, 0.125, 0.0400, 0.000, 0.43, 7, false)
	for i, v in pairs(MoneyPickupList) do
   			VehicleMenuGUI.addButton("MoneySpawnerMenu", i, SpawningOptions.SpawnPickupMoney, v, false, 0.35, 0)
	end
	VehicleMenuGUI.addButton("MoneySpawnerMenu", "~b~C~y~l~b~o~y~s~b~e", VehicleMenuGUI.setActiveMenu, "SpawningOptions", false, 0.35, 0)
	
	
	
	VehicleMenuGUI.createMenu("ObjectSpawner", "SpawningOptions", "~b~O~y~b~b~j~y~e~b~c~y~t ~b~S~y~p~b~a~y~w~b~n~y~e~b~r~n~~h~~y~ ∑~b~-------------~y~∑", 0.93, 0.04, 0.125, 0.0625, 0.000, 0.5, 7)
	VehicleMenuGUI.addButton("ObjectSpawner", "Object WIP Spawner", VehicleMenuGUI.setActiveMenu, "ObjectSpawnerMenu1", false, 0.35, 0)
	VehicleMenuGUI.addButton("ObjectSpawner", "Remove Objects", SpawningOptions.RemoveSpawnedObjects, nil, false, 0.35, 0)
	VehicleMenuGUI.addButton("ObjectSpawner", "~h~~y~ Close~n~~h~~y~∑~b~----------------------------~y~∑", MainMenu.CloseMenu, "", false, 0.35, 0)
	
	
	for i, v in pairs(ObjectModelList) do
		local prevMenu = "ObjectSpawnerMenu" .. i - 1
		local nextMenu = "ObjectSpawnerMenu" .. i + 1

		if prevMenu == "ObjectSpawnerMenu0" then prevMenu = "ObjectSpawner" end
		if nextMenu == "ObjectSpawnerMenu3229" then nextMenu = "ObjectSpawnerMenu3228" end
		VehicleMenuGUI.createMenu("ObjectSpawnerMenu" .. i, prevMenu, "~b~O~y~b~b~j~y~e~b~c~y~t~b~s (" .. i .. "/3228)", 0.93, 0.04, 0.125, 0.0400, 0.000, 0.43, 7, false)
		VehicleMenuGUI.addButton("ObjectSpawnerMenu" .. i, "~b~N~y~e~b~x~y~t", VehicleMenuGUI.setActiveMenu, nextMenu, false, 0.35, 0)

		for _, model in pairs(v) do
			VehicleMenuGUI.addButton("ObjectSpawnerMenu" .. i, model, SpawningOptions.SpawnObject, model, false, 0.35, 0)
		end

		VehicleMenuGUI.addButton("ObjectSpawnerMenu" .. i, "~b~C~y~l~b~o~y~s~b~e", VehicleMenuGUI.setActiveMenu, "SpawningOptions", false, 0.35, 0)
	end
	
	
end


-- spawningoptions Onerror 
function SpawningOptions:OnError()
	--self:Kill()
	--addon.Load("RENAMEME")
end